/* File: forsinc2.c
   Calculate function sinc(x)=sin(x)/x
   for x from -10 to 10 with step size 5,
   without checking if x is a value less than epsilon */
#include <stdio.h>
#include <math.h>   /* for sin() and fabs() */
#include <float.h>  /* for FLT_EPSILON */


int main() {
    double x, x0, xf, xstep, result;
    int i, n;

    printf("    x     sinc(x)\n");
    printf(" ----------------\n");
    x0 = -10.0;                  /* initial value for x */
    xf = 10.0;                   /* final value for x */
    xstep = 5.0;                 /* step size for x */
    n  =  (xf - x0)/xstep + 1;   /* number of points */
    for(i = 0; i < n; i++) {
       x = x0 + i*xstep;         /* calculate value x */
       /* calculate sinc(x) without checking 
          if x is a value less than epsilon */
       result = sin(x)/x;

       /* display the result */
       printf("%8.4f %8.4f\n", x, result);
    }
    return 0;
}
