/* File: accelfunc2D.cpp 
   Plot acceleration curves on the same figure with 11 and 100 points each. */
#include <stdio.h>
#include <math.h>
#include <chplot.h>   /* for class CPlot for plotting */
#define M_G   9.81    /* gravitational acceleration constant g */

/* function accel() to be plotted */
double accel(double t) {
    double mu, m, a, p;

    mu = 0.2;
    m = 5.0;
    p = 4*sin(t-3)+20;
    a = (p-mu*m*M_G)/m;
    return a;
}

int main() {
    double t0 = 0, tf = 10.0;   /* time t from t0 to tf */
    int num1 = 11, num2 = 100;  /* with 11 and 100 points */
    CPlot plot;                 /* instantiate a plotting class */

    /* use a plotting class plot two curves on the same figure */
    /* set title of the plot */
    plot.title("Acceleration Plot");
    /* set the label on the x-axis */
    plot.label(PLOT_AXIS_X, "time (s)");
    /* set the label on the y-axis */
    plot.label(PLOT_AXIS_Y, "accel (m/s^2)");
    /* set the 1st function accel() to be plotted 
       from t0 to tf with num1 points */
    plot.func2D(t0, tf, num1, accel);    
    /* set the legend for the 1st curve */
    plot.legend("11 points", 0);
    /* set the 2nd function accel() to be plotted 
       from t0 to tf with num2 points */
    plot.func2D(t0, tf, num2, accel);    
    /* set the legend for the 2nd curve */
    plot.legend("100 points", 1);
    /* after the above setup, ready and go, plot and display it! */
    plot.plotting();          
    return 0;
}
