/* File: accelsinmptsplot.cpp */
#include <stdio.h>
#include <math.h>
#include <chplot.h>
#define M_G   9.81  /* gravitational acceleration constant g */

double force(double t) {
    double p;
    p = 4*sin(t-3)+20;
    return p;
}

double accel(double t) {
    double mu, m, a, p;

    mu = 0.2;
    m = 5.0;
    p = force(t);
    a = (p-mu*m*M_G)/m;
    return a;
}

int main() {
    double t0 = 0, tf = 10;
    int num = 100;

    fplotxy(accel, t0, tf, num, "Acceleration Plot", 
            "time (s)", "accel (m/s^2)");
    return 0;
}
