/* File: accelsinplot.cpp 
   Plot acceleration versus time for time from 0 to 10 seconds.
   It uses 11 points of data for the plotting */
#include <stdio.h>
#include <math.h>
#include <chplot.h>
#define M_G   9.81  /* gravitational acceleration constant g */

double force(double t) {
    double p;
    p = 4*sin(t-3)+20;
    return p;
}

double accel(double t) {
    double mu, m, a, p;

    mu = 0.2;
    m = 5.0;
    p = force(t);
    a = (p-mu*m*M_G)/m;
    return a;
}

int main() {
    double t0 = 0, tf = 10.0;
    int num = 11;

    /* plot function accel() from t0 to tf with 11 points.
       The curve in the plot is not smooth for 11 points. 
       The value for num can be changed to 100 to get a smooth curve.
       The title of the plot is "Acceleration Plot".
       the label for x-coordinate is "time (s)",
       the label for y-coordinate is "accel (m/s^2)" */
    fplotxy(accel, t0, tf, num, "Acceleration Plot", 
            "time (s)", "accel (m/s^2)");
    return 0;
}
