/* File: hat.cpp
   Plot a 3D surface for sinr(x,y)=sin(sqrt(x*x + y*y))/sqrt(x*x + y*y). */
#include <math.h>
#include <chplot.h>   /* for 3D plotting function fplotxyz() */

/* function sinr() with two variables to be plotted */
double sinr(double x, double y) {
    double r, retval;
    
    r = sqrt(x*x + y*y);
    retval = sin(r)/r;
    return retval;
}

int main() {
    /* plotting  with -10<=x<=10, -10<=y<=10 */ 
    double x0 = -10.0, xf = 10.0, y0 = -10.0, yf = 10.0;
    /* use 80 points for x-coordinate, 100 points for y-coordinate */
    int numx = 80, numy = 100;
 
    /* plot sinr() for x from x0 to xf with numx points,
       y from y0 to yf with numy points. 
       The title, labels for x, y, and z coordinates are 
       "function sinr(x, y)", "x", "y", "sinr", respectively. */
    fplotxyz(sinr, x0, xf, y0, yf, numx, numy,
             "function sinr(x, y)", "x", "y", "sinr");
    return 0;
}
