/* File: projectilefunc.cpp
   Plot a projectile based on the function y(x). */
#include <math.h>
#include <chplot.h>  /* for fplotxy() */ 
#define M_G   9.81  /* gravitational acceleration constant g */

/* function for the y-coordinate of the projectifle */
double func(double x) {
   double theta0,        /* initial velocity */
          v0,            /* projection angle */
          y;             /* y coordinate */

   v0 = 35.0;            /* set the initial velocity */
   theta0 = 15*M_PI/180; /* calculate the projection angle in radians */
   /* calculate the y coordinate */
   y = tan(theta0)*x - M_G*x*x/(2*v0*v0*cos(theta0)*cos(theta0));
   return y;
}

int main() {
   double theta0, v0;            /* projection angle and initial velocity */
   double x0 = 0, xf;            /* initial and final distances, x0 is 0 */ 
   int num = 100;                /* number of points for plotting */

   /* calculate the final distance xf for x based on v0 and theta0 */
   v0 = 35.0;                    /* initial velocity */
   theta0 = 15*M_PI/180;         /* projection angle in radians */
   xf = v0*v0*sin(2*theta0)/M_G; /* the distance in the x direction */
   /* plot y version x for x from 0 to xf with num points */
   fplotxy(func, x0, xf, num, 
           "A projectile with the initial projection angle of 15 degrees", 
           "x (m)", "y (m)"); 
   return 0;
}
