/* File: accelhead.c
   Calculate the acceleration with a header file */
#include <stdio.h> /* system header file for the standard input/output lib */
#include <math.h>  /* system header file for the standard math lib */
#include "accel.h" /* user's local header file */

int main() {
    /* declare variables */
    double a, p, mu, m, t;

    /* Initialize variables */
    mu = 0.2;
    m = 5.0;
    t = 2.0;

    /* processing */
    a = accel(t, mu, m);

    /* display output and termination */
    printf("Acceleration = %f (m/s^2)\n", a);
    return 0;
}

/* function definition for calculating force */
double force(double t) {
    double p;

    p = 4*sin(t-3)+20;
    return p;
}

/* function definition for calculating acceleration */
double accel(double t, double mu, double m) {
    double a, p;

    p = force(t);
    a = (p-mu*m*M_G)/m;
    return a;
}
