/* File: accelmacro.c
   Calculate the acceleration using a macro */
#include <stdio.h>
#include <math.h>          /* for sin() */

/* define macros for g, force, and acceleration */
#define M_G   9.81 
#define FORCE(t)           (4*(sin((t)-3))+20)
#define ACCEL(p, mu, m)    (((p)-(mu)*(m)*M_G)/(m))

int main() {
    double a, p, mu, m, t; /* declare variables */

    mu = 0.2;              /* set mu */
    m = 5.0;               /* set mass to 5 kg */
    t = 2.0;               /* set time to 2 seconds */
    p = FORCE(t);          /* use macro to calculate the force */
    a = ACCEL(p, mu, m);   /* use macro to calculate the accel */
    printf("Acceleration = %f (m/s^2)\n", a);
    return 0;
}
