/* File: printerror.c (run in C99 and Ch only)
   Compile in gcc, use command 'gcc -std=c99 pointerror.c' 
   A generic macro to print out file name, function, and line number.
   The program uses C99 feature __func__ */
#include <stdio.h>

/* define the macro printerror() to print out file name, 
   function, and line number */
#define printerror()  printf("Error in %s:%s():%d\n", \
                       __FILE__, __func__, __LINE__);

/* two functions using the define macro */
void funcname1() {
    printerror();     /* Line 14 */
}
void funcname2() {
    printerror();     /* Line 17 */
}

int main() {
    /* call functions that invokes the macro */
    funcname1();
    funcname2();
    return 0;
}
