/* File: accelexternfunc.c
   Define global variable g_a and functions initialize() and accel()
   used by the source file accelextern.c. Static variable p and
   function force() with scope is used for implementation of accel(). */
#include <math.h>
/* header file "accelextern.h" contains declarations of external 
   variables and function prototypes */
#include "accelextern.h"  

/* declare global variable and function prototype with file scope */
double g_a;       /* declare global variable g_a */
static double p;  /* declare static variable p  with file scope */
static void force(double t); /* static function force() with file scope */

/* static function with file scope. It uses static variable p */
static void force(double t) {
    p = 4*sin(t-3)+20;
}

/* a global function using static variable p and global variable g_a */
void initialize(void) {
    p = 0;
    g_a = 0;
}

/* a global function calling static function and using
   global variable g_a and static variable p */
void accel(double t, double mu, double m) {
    force(t);
    g_a = (p-mu*m*M_G)/m;
}
