/* File: global.c
   Demonstrate the usage of global variables  */
#include <stdio.h>

int g = 10;     /* declare global variable g */

void func1(void) {
    g++;        /* use global variable g */
    printf("g in func1() = %d\n", g);
}

void func2(void) {
    g++;        /* use global variable g */
    printf("g in func2() = %d\n", g);
}

void func3(void) {
    int g = 0;     /* declare and initialize local variable g */

    g++;
    printf("g in func3() = %d\n", g);
}

int main() {
    func1(); /* use global variable g */
    func2(); /* use global variable g */
    func3(); /* use local variable g */
    printf("g in main() = %d\n", g);
    return 0;
}
  
