/* File: projectileglobal.cpp
   Plot a projectile based on the function y(x) using global variables
   for theta0 and v0 */
#include <math.h>
#include <chplot.h> /* for fplotxy() */

#define M_G   9.81 /* gravitational acceleration constant g */
double theta0, v0; /* declare global variables */

double func(double x) {
   double y;

   /* calculate the y coordinate */
   y = tan(theta0)*x - M_G*x*x/(2*v0*v0*cos(theta0)*cos(theta0));
   return y;
}

int main() {
   double x0 = 0, xf;            /* initial and final distances, x0 is 0 */
   int num = 100;                /* number of points for plotting */

   v0 = 35.0;                    /* initial velocity */
   theta0 = 15*M_PI/180;         /* projection angle in radian  */
   xf = v0*v0*sin(2*theta0)/M_G; /* the distance in the x direction */
   fplotxy(func, x0, xf, num, 
           "A projectile with the initial projection angle of 15 degrees", 
           "x (m)", "y (m)"); 
   return 0;
}
