/* File: scopeid.c
   Demonstrate the scope of identifiers */
#include <stdio.h>

int program_i = 10;      /* declare a global variable with program scope */
/* extern int otherfile_i; if otherfile_i is declared in other file */
static int file_i  = 20; /* declare a static variable with file scope */
void func(void) {
    int function_i = 30; /* declare a variable with function scope */

    /* display values of variables accessible inside this function */ 
    printf("program_i in func() = %d\n", program_i); 
    printf("file_i in func() = %d\n", file_i); 
    printf("function_i in func() = %d\n", function_i); 
    {
       int block_i = 40; /* declare a variable with block scope */
       /* display values of variables accessible inside this block */ 
       printf("program_i in block = %d\n", program_i); 
       printf("file_i in block = %d\n", file_i); 
       printf("function_i in block = %d\n", function_i); 
       printf("block_i in block = %d\n", block_i); 
    }

}
int main() {
    /* variables in program or file scope can be accessed 
       in any function in a file;
       display values of variables accessible inside this function */ 
    printf("program_i in main() = %d\n", program_i); 
    printf("file_i in main() = %d\n", file_i); 
    /* call function func() to display values of variables
       accessible inside the function */
    func();
    return 0;
}
  
