/* File: declaredefer.c
   Demonstration of declaration of deferred-shape arrays */
int n1;        /* declare global variable n1 with allocation of memory */
extern int n2; /* declare extern variable n2 without allocation of memory */

int funct1(int i) {  /* function definition */
    return i*i;
}

void funct2(int m, int n) {
    int i = 8*n;
    int j = 0, k = -9;
    int a[i][4];        /* OK */
    int b[m][3];        /* OK: mix fixed-extent with deferred-extent */
    int c[n*m][n];      /* OK */
    int d[funct1(n)][3*funct1(i)]; /* use function in the array size */
    int e[n1][n2*n];               /* OK, n1 declared, n2 declared */
    int f[n3];         /* ERROR: n3 has not been defined yet */
    int g[j];          /* ERROR: zero size (j is 0) */
    int h[k];          /* ERROR: negative size (k is -9) */
    static int p[m];   /* ERROR: static VLA */
    int q[m] = {1, 2}; /* ERROR: initialize VLA  */
}
int n2 = 10, n3 = 20;  /* declare n2 and n3 with allocation of memory */
