/* File: helix.cpp
   Plot 3D curve using plotxyz() */
#include <math.h>
#include <chplot.h> /* for plotxyz() */

#define N 300       /* number of data points for the 3D curve */

int main() {
    /* declare arrays for plotting, t is coordinates in z-axis  */
    double t[N], x[N], y[N];
    int i;

    /* fill the array with the data based on the formula for a helix curve */
    for(i=0; i<N; i++) {
        t[i] = 10*M_PI*i/(N-1); /* data in time for z-axis */
        x[i] = sin(t[i]);       /* data in x-axis */
        y[i] = cos(t[i]);       /* data in y-axis */
    }     
    /* plot 3D curve using plotxyz() */
    plotxyz(x, y, t, N, "Helix", "sin(t)", "cos(t)", "t");
    return 0;
}
