/* File: linearreg.c
   A linear regression analysis function using 
   function mean() in statlib.h and statlib.c */
#include "statlib.h"  /* for mean()  in the statistical lib */

/* A linear regression function, n is the size for arrays t and y of input data.
   coeff[2] is the output array with TWO elements for regression coefficients */
void linearreg(int n, double t[], double y[], double coeff[2]) {
    /* mean values and sums in the formulas for regression analysis */
    double t_mean, y_mean, titm, sumty, sumts;
    int i;

    /* calculate the linear regression coefficients based on the formulas */
    t_mean = mean(n, t);
    y_mean = mean(n, y);
    for(i=0; i<n; i++) {
       titm = t[i] - t_mean;
       sumty = titm*(y[i]-y_mean);
       sumts = titm*titm;
    }
    coeff[1] = sumty/sumts;
    coeff[0] = y_mean - coeff[1]*t_mean;
}
