/* File: matvecmul.c
   Calculate matrix equation b = Ax using function matvecmul() using 
   VLA in C99. Compile in gcc, use command 'gcc -std=c99 matvecmul.c' */
#include <stdio.h>

#define M 3    /* number of rows */
#define N 3    /* number of columns */

void matvecmul(int m, int n, double a[m][n], double v[n], double b[m]) {
    int i, j;  /* array indices */

    /* multiply row-by-row */
    for(i=0; i<m; i++) {
        b[i] = 0;
        for(j=0; j<n; j++) {
            b[i]+= a[i][j]*v[j];
        }
    }
}

int main() {
    /* declare and initialize matrix A and vector x, declare b */
    double a[M][N] = {3, 5, 6,
                      4, 2, 1,
                      0, 7, 1};
    double x[N] = {2, 1, -2}, b[M];

    matvecmul(M, N, a, x, b);
    printf("b = %g, %g, %g\n", b[0], b[1], b[2]); /* printing vector b */
    return 0;
}
