/* File: pass2Dcarrayvla.c (run in C99 and Ch only)
   Compile in gcc, use command 'gcc -std=c99 pass2Dcarrayvla.c' 
   Calculate the sum of all elements of two-dimensional arrays
   by passing of variable length to a function using VLA in C99. 
   It can be compiled by a C compiler/interpreter which 
   supports this new feature in C99, such as Ch and gcc */
#include <stdio.h>
#include <stdlib.h>

/* define macro for different extents of arrays */
#define M1 2
#define N1 3
#define M2 3
#define N2 4

/* possible function prototype for VLA */
double func(int m, int n, double a[m][n]);
/* or double func(int m, int n, double a[*][*]); */
/* or double func(int, int, double [*][*]); */

int main() {
    /* declare and initialize arrays a1 and a2 with different extents */
    double a1[M1][N1]={1.0, 2.0, 3.0, 4.0, 5.0, 6.0};
    double a2[M2][N2]={1.0, 2.0, 3.0, 4.0, 5.0, 6.0,
                       7.0, 8.0, 9.0, 10.0, 11.0, 12.0};
    double sum; /* sum for all elements of an array */

    sum = func(M1, N1, a1);    /* calculate the sum for array a1 */
    printf("sum = %f\n", sum); /* display sum for array a1 */

    sum = func(M2, N2, a2);    /* calculate the sum for array a2 */
    printf("sum = %f\n", sum); /* display sum for array a2 */
    return 0;
}

/* function to calculate the sum of two-dimensional arrays with 
   different extents */
double func(int m, int n, double a[m][n]) {
    double sum = 0;            /* declare and initialize sum */
    int i, j;                  /* declare index variables for loops */

    for(i=0; i<m; i++) {
        for(j=0; j<n; j++) {
            sum += a[i][j];    /* sum all elements one by one */
        }
    }
    return sum;                /* return the sum */
}
