/* File: passarray2d.c
   Pass two dimensional arrays of fixed length to a function */
#include <stdio.h>

/* The column of arrays is fixed with 3. */
double twoDadd(int m, int n, double dd1[][3], double dd2[][3], double dd3[2][3])
{
    int i, j;       /* variable for loop indexes */
    double sum = 0; /* declare and initialize sum to 0 */

    for(i = 0; i < m; i++) {
        for(j = 0; j < n; j++) {
            /* add arrays dd2 and dd3 element wise, and save the result 
               in array dd1 */
            dd1[i][j] = dd2[i][j]+dd3[i][j];
            sum += dd1[i][j]; /* add each element of array dd1 */
        }
    }
    return sum; /* return the sum for all elements of arrays dd2 and dd3 */
}
 
int main() {
    /* declare arrays and initialize them */
    double d1[2][3], 
           d2[2][3]={{1.0, 2.0, 3.0}, {4.0 ,5.0 ,6.0}},
           d3[2][3]={{1.0, 2.0, 3.0}, {4.0 ,5.0 ,6.0}},
           sum; /* sum for all elements of arrays dd2 and dd3 */
    int i, j;   /* variable for array indexes */
		   
    sum =twoDadd(2, 3, d1, d2, d3); /* call function for d1 = d2 + d3 */
    /* display sum and array d1 with d1 = d2 + d3 */
    printf("sum = %.2f\n", sum);
    printf("d1 = \n");
    for(i = 0; i < 2; i++) {
        for(j = 0; j < 3; j++) {
            printf("%8.2f", d1[i][j]);
        }
        printf("\n");
    }
    return 0;
}
