/* File: projectile.cpp */
#include <math.h>
#include <chplot.h>

#define M_G 9.81     // gravitational acceleration constant g 
#define N 100        // number of points for plotting 

int main() {
    int i;
    double v0, theta0, xf, x[N], y[N];

    v0 = 35.0;                       // initial velocity
    theta0 = 15*M_PI/180;            // projection angle in radian 
    xf = v0*v0*sin(2*theta0)/M_G;    // the distance in the x direction
    for(i=0; i<N; i++) {
        x[i] = i*xf/(N-1);
        y[i] = tan(theta0)*x[i] - 
               M_G*x[i]*x[i]/(2*v0*v0*cos(theta0)*cos(theta0));
    }
    plotxy(x, y, N, 
      "A projectile with the initial projection angle of 15 degrees", "x", "y");
    return 0;
}
