/* File: sort.c 
   Sort an array using the selection sort with one swap in an iteration */
#include <stdio.h>

#define N 8   /* number of elements for array a */

int main() {
    /* declare array a with initialization */
    double a[N] = {3.0, 21.0, 0.0, -3.0, 34.0, -14.0, 45.0, 18.0};
    double temp;    /* temporary for swap */
    int i, j, imin; /* variables for array index */
    
    printf("The original data:\n"); 
    for(i = 0; i < N; i++) {  /* print the original array */
        printf("%g ", a[i]);
    }
    printf("\nThe sorted data in each iteration:\n");
    /* select the smallest value in the remaining part of 
       the array in each iteration starting with a[i] */
    for(i = 0; i < N-1; i++) {   
        imin = i; /* assume the first element is the minimum */
        /* compare a[imin] with a[j] for j from i+1 to N-1 */
        for(j = i+1; j < N; j++) { 
            if(a[imin] > a[j]) { /* if a[j] is smaller, it is the new min */
                imin = j;        /* remember its index */
            }
        }
        if(imin != i) {          /* swap the values of a[i] and a[imin] */
            temp = a[i];
            a[i] = a[imin];
            a[imin] = temp;
        }
        for(j = 0; j < N; j++) { /* print the array in each iteration */
            printf("%g ", a[j]);
        }
        printf("\n");
    }
    return 0;
}
