/* File: daystr.c
   Use array of pointers */
#include <stdio.h>
#define DAY 7

/* function returns a pointer to char which points to 
   a string for each day of the week */
const char *daystr(int n) {
    /* a static variable with the static storage duration.  Even after
       the function is called, the memory for day is still valid */ 
    static const char *day[7] = {"Sunday", "Monday", "Tuesday", 
                "Wednesday", "Thursday", "Friday", "Saturday"};
    /* Use a conditional operator to return either NULL or a valid string 
       depending on the passed argument. */
    return (n < 0 || n > 6) ? NULL : day[n];
}

int main() {
    int i;
    const char *p;
   
    /* print the string for each day of a week */
    for(i = 0; i < DAY; i++) {
        p = daystr(i);
        printf("%s\n", p);
    }
    return 0;
}
