/* File: decompose.c 
   Decompose a floating-point number into integral part and fractional part */
#include <stdio.h> 
#include <limits.h>    /* INT_MAX */       

/* function decomposes x into integral and fractional parts. The integral part 
   is passed by pointer iptr and the fractional part is returned. */
double decompose(double x, double *iptr) {
   int i;

   i = (int) x;   /* get the integral part, it must be smaller than INT_MAX */
   *iptr  = (double)i; /* pass back to the calling function */
   return x - i;       /* return the fractional part */
}

int main() {
    /* variables for x, integral and fractional parts */
    double x, intpart, fracpart; 

    printf("Please input a floating-point number smaller than %d\n", INT_MAX);
    scanf("%lf", &x);

    fracpart = decompose(x, &intpart);
    printf("The integral part of %f is %.f, and fractional part is %f\n",
           x, intpart, fracpart);
    return 0;
}
