/* File: funptrarg.c
   Function with an argument of pointer to functions */
#include <stdio.h>

/* declare FUNCPTR as a data type of pointer to function
   with an argument of type double and return type int */ 
typedef int (*FUNCPTR)(double);
/* function prototype using FUNCPTR */
int f2(FUNCPTR pf, double f); 

/* a function with an argument of type double and return type int */ 
int f1(double f) {
    printf("f = %f\n", f);
    return 0;
}

/* function with an argument of pointer to functions
   with an argument of type double and return type int. 
   These two are alternative function headers 
      int f2(int (*pf)(double), double f)
      int f2(int pf(double), double f) */
int f2(FUNCPTR pf, double f) 
{
    pf(f); 
    return 0;
}

int main() {
    f2(f1, 5.0); /* pass f1 to f2(). Inside f2(), f1() is called 
                    indirectly through pf(). */
    return 0;
}
