/* File: pass1Dcarray.c 
   Calculate the sum of an array using a function by passing arrays
   as an argument. */
#include <stdio.h>
#include <stdlib.h>
double func(int n, double *a);

int main() {
    /* declare and initialize arrays of diff dimensions and extents */
    double a[5] = {1.0, 2.0, 3.0, 4.0, 5.0};       /* 1D with 5 elements */
    double b[6] = {1.0, 2.0, 3.0, 4.0, 5.0, 6.0};  /* 1D with 6 elemtns */
    double c[2][3] = {1.0, 2.0, 3.0, 4.0, 5.0, 6.0}; /* 2D array */
    double sum; /* declare sum */
     
    sum = func(5, a);          /* calculate the sum for array a */
    printf("sum = %f\n", sum); /* display sum for array b */

    sum = func(6, b);          /* calculate the sum for array b */
    printf("sum = %f\n", sum); /* display sum for array b */

    /* sum = func(2*3, c); may get warning in some C/C++ compilers */
    sum = func(2*3, &c[0][0]); /* calculate the sum for array c */
    printf("sum = %f\n", sum); /* display sum for array c */
    return 0;
}

/* a function to calculate the sum of one-dimensional arrays with
   different extents using a pointer  */
double func(int n, double *a) {
    double sum = 0;           /* declare and initialize sum */
    int i;                    /* declare index variable for loop */

    for(i=0; i<n; i++) {
       sum += *(a+i);           /* sum all elements one by one */
    }
    return sum;                /* return the sum */
}
