/* File: pass2Dcarray.c 
   Calculate the sum of all elements of two-dimensional arrays by 
   passing of variable length to a function using pointers to pointers. */
#include <stdio.h>
#include <stdlib.h>  /* for malloc() and free() */
/* define macro for different extents of arrays */
#define M1 2
#define N1 3
#define M2 3
#define N2 4
double func(int m, int n, double **aa); /* function prototype */

int main() {
    /* declare and initialize arrays a1 and a2 with different extents */
    double a1[M1][N1]={1.0, 2.0, 3.0, 4.0, 5.0, 6.0};
    double a2[M2][N2]={1.0, 2.0, 3.0, 4.0, 5.0, 6.0,
                       7.0, 8.0, 9.0, 10.0, 11.0, 12.0};
    /* declare pointers to pointers for passing arrays of diff length */
    double **pa1, **pa2, sum;  /* also declare sum */
    int i;                     /* index variable for for-loop */

    /* allocate array of pointers for each row */
    pa1 = (double **)malloc(M1*sizeof(double*)); 
    for(i=0; i<M1; i++) {
        pa1[i] = a1[i];        /* pa1[i] points to i-th row of a1 */
    }
    printf("a1[1][1] = %f, pa1[1][1] = %f\n", a1[1][1], pa1[1][1]);
    sum = func(M1, N1, pa1);   /* calculate the sum for array a1 */
    printf("sum = %f\n", sum); /* display sum for array a1 */
    free(pa1);                 /* free allocated array  */

    /* allocate array of pointers for each row */
    pa2 = (double **)malloc(M2*sizeof(double*));
    for(i=0; i<M2; i++) {
        pa2[i] = a2[i];        /* pa2[i] points to i-th row of a2 */
    }
    printf("a2[1][1] = %f, pa2[1][1] = %f\n", a2[1][1], pa2[1][1]);
    sum = func(M2, N2, pa2);   /* calculate the sum for array a2 */
    printf("sum = %f\n", sum); /* display sum for array a2 */
    free(pa2);                 /* free allocated array */
    return 0;
}

/* function to calculate the sum of two-dimensional arrays with
   different extents */
double func(int m, int n, double **a) {
    double sum = 0;            /* declare and initialize sum */
    int i, j;                  /* declare index variables for loops */

    for(i=0; i<m; i++) {
        for(j=0; j<n; j++) {
            sum += a[i][j];    /* sum all alements one by one */
        }
    }
    return sum;                /* return the sum */
}
