/* File: strcopymem.c
   Copy a string. The source string is const-qualified */
#include <stdio.h>
#include <stdlib.h>      /* for malloc() and free() */
#include <string.h>      /* for strlen() */

/* Function copying string from sp to dp.
   string pointed to by sp does not need to be modified inside the function.
   To make this intention clear, it is const-qualified so that
   it cannot be modified inside the function.  */  
char *strcopy(char *dp, const char *sp) {
    char *retp = dp;
     /* copy each character, including the null terminating character,
        from string sp to string dp */
    while(*dp++ = *sp++)
       ;
    return retp;  /* return the passed dp */
}

int main() {
     const char *src = "original string"; /* original string */
     char *dest;                          /* destination string */

     /* allocate memory for string dest */
     dest = (char *) malloc(sizeof(char)*(strlen(src) + 1)); 
     if(dest == NULL) {  /* when mallc() failed */
        printf("Error: no memory\n");
        return -1;
     }
     else {
        strcopy(dest, src);             /* copy src to dest */
        printf("dest = %s\n", dest);    /* display the copied string */
        free(dest);                     /* free allocated memory */
        return 0;
     }
}
