/* File: swap.c
   A call-by-reference through indirection operation of pointers in C */
#include <stdio.h>

/* a function to swap objects pointed by pa and pb 
   in the calling function by indirection operations */
void swap(int *pa, int *pb) {
    int temp;    /* temporary variable */

    /* swap values pointed by pa and pb in the calling function
       by indirection operations */
    temp = *pa;
    *pa = *pb;
    *pb = temp;
    return;
}

int main() {
    int a = 5, b = 6;   /* declare and initialize a and b */

    swap(&a, &b);       /* swap a and b by passing the addresses of a and b */
    printf("a = %d, b = %d\n", a, b); /* output is a = 6, b = 5, swap! */
    return 0;
}


