/* File: commandline.c 
   Process command line argument with options -a or -av etc. */
#include <stdio.h>
#include <stdlib.h>   /* for exit() */

#define TRUE  1         /* define boolean value true */
#define FALSE 0         /* define boolean value false */

int main(int argc, char *argv[]) {
  char *s, *cmd;        /* declare variables s and cmd */
  int a_option = FALSE; /* default, no -a option */
  int v_option = FALSE; /* default, no -v option */

  cmd = argv[0];        /* save cmd in argv[0] */ 
  if(argc == 1){        /* no argument */
      printf("Usage: %s [-av] names \n", cmd);
      exit(EXIT_FAILURE);
  }

  argc--; argv++;  /* skip the command, the 1st one in the argument list */
  /* process each argument beginning with - */
  while(argc > 0 && **argv == '-') {
      /* empty space is not valid option */
      /* use a for-loop to handle multiple options followed 
         with '-' such as as '-av', "s = argv[0]+1" skips '-'  */
      for(s = argv[0]+1; *s!='\0'; s++) 
      {
         switch(*s) /* compare the character */
         {
           case 'a':         /* if it is 'a' in '-a', '-av', or '-va' */
             a_option = TRUE;      
             break;
           case 'v':          /* if it is 'v' in '-v', '-av', or '-va' */
             v_option = TRUE; 
             break;
           default:            /* unknown character such as 'w' in '-w' */
             printf("Warning: invalid option %c\n", *s);
             printf("Usage: %s [-av] names \n", cmd);
             break;
         }
      }
      argc--; argv++;          /* move to the next argument */
  }

  /* when options -a and/or -v is on the command line, print it */
  if(a_option) 
      printf("option -a is on\n");
  if(v_option) 
      printf("option -v is on\n");
  while(argc > 0) { /* print out the remaining arguments  */
      printf("%s\n",  *argv);
      argc--; argv++;
  }
  return 0;
}
