/***********************************************************
*  File:        getnum.c 
*  Description: Function returns default number (when RETURN 
*               or ENTER is entered) or new number from stdin
*  Input:       
*    msg:       displayed message
*    d:         default number
*  Output:      return default or new number
*  Note:        this file is the same as getnum.chf in Ch
***********************************************************/
#include <stdio.h>  /* for NULL, printf(), fgets(), BUFSIZ */
#include <stdlib.h> /* for strtod() */
#include <string.h> /* for strlen() */

double getnum(char *msg, double d) {
  char buf[BUFSIZ],*endptr, *chp;
  int gettingNum = 1; /* initialize to 1 for true */

  if(msg!=NULL)           /* when there is a message, display it */
     printf("%s\n", msg);
  while (gettingNum) {  /* infinite loop, until valid number is entered*/ 
     chp = fgets(buf, BUFSIZ, stdin); /* get the user input */
     if(strlen(chp)==1)  /* if just hit ENTER, return default value */ 
         return d;
     buf[strlen(chp)-1] = '\0';/* get rid of the newline char '\n' */
     d = strtod(buf, &endptr); /* change string to double */
     if (strlen(endptr)>0)     /* when invalid number is entered */
         printf("\a%s: invalid number, try again: ",buf);
     else                      /* got a valid number, quit while-loop */
         gettingNum = 0;       /* set to 0 to quit while-loop */
  }
  return d;                     /* return the user entered number */
}
