/* File: memcopy.c
   Copy contents in the memory using memcpy() */
#include <stdio.h> 
#include <string.h>  /* for memcpy() */

int main() {
  /* declare strings */
  char s1[10]="ABCD1234", s2[10];
  char *p;  /* declare p as a pointer to char */
  /* declare variables d1 and d2 of double type, dp of pointer to double */
  double d1 = 12.1234, d2, *dp; 

  /* for strings, memcpy() is the same as strcpy() */
  p = memcpy(s2, s1, 6);     /* copy 6 characters from s1 to s2 */
  printf("s1 = %s\n", s1);   /* print s1 */
  s2[6] = '\0';              /* append a null terminating character */
  printf("s2 = %s\n", s2);   /* print string s2 */
  printf("p = %s\n", p);     /* print string s2 through p */

  /* memcpy() can be used to copy objects of other types */
  /* copy an object of double, form d1 to d2 */
  dp = (double *)memcpy((void*)&d2, (void *)&d1, sizeof(double));
  printf("d2 = %f\n", d2);   /* print d2 */
  printf("*dp = %f\n", *dp); /* print d2 through dp */
  return 0;
}
