/* File: bisect3.c */
#define M_G   9.81       /* gravitational acceleration constant g */

struct InitCond {       /* define struct InitCond */
   double theta0;       /* initial velocity  */
   double v0;           /* member for initial velocity */
};


double traj(double x, void *param) {
   double theta0,        /* projection angle  */
          v0,            /* initial velocity */
          y;             /* y coordinate */
   struct InitCond *initcptr;

   /* cast from (void *) for param to (struct InitCond *) for initcptr */
   initcptr = (struct InitCond *)param; 
   theta0 = initcptr->theta0; /* projection angle */
   v0 = initcptr->v0;         /* initial velocity */
   y = tan(theta0)*x - M_G*x*x/(2*v0*v0*cos(theta0)*cos(theta0));
   return y;
}

int main() {
    ...
    struct InitCond initc;
    initc.theta0 = 15*M_PI/180; /*  the projection angle in radians */
    initc.v0 = 35.0;            /* set the initial velocity */
    status = bisect2(&x, x0, xf, tolerance, traj, &initc);
    ...
}
