/* File: bitfield.c 
   Demonstrates bit-fields */
#include <stdio.h>

struct tag1 {            /* define a regular structure */ 
    int a;              /* declare a as a member of int */
    unsigned int b;     /* declare b as a member of unsigned int */
    unsigned int c;     /* declare c as a member of unsigned int */
} s1 = {1, 2, 3};       /* declare s1 as struct tag1 */

struct tag2 {          /* declare a structure with bitfields */
    int a : 4;          /* declare a as a bit-field of int with 4 bits */
    unsigned int b : 4; /* b as a bit-field of unsigned int with 4 bits */
    unsigned int c : 4; /* c as a bit-field of unsigned int with 4 bits */
} s2 = {1, 2, 3};       /* declare s2 as struct tag2 */

int main() {
    s2.c = 4;            /* assign 4 to bit-field c of s2 */

    /* print and compare ssize of struct tag1 and struct tag2 */
    printf("sizeof tag1 is %u\n", sizeof(struct tag1));
    printf("sizeof tag2 is %u\n", sizeof(struct tag2));

    /* print out each members of bit-fields of structure tag2 */
    printf("s2.a = %d\n", s2.a);
    printf("s2.b = %d\n", s2.b);
    printf("s2.c = %d\n", s2.c);
    return 0;
}

