/* File: nested.c
   Use a nested structure */
#include <stdio.h>      
#include <string.h>            /* for strcpy() */

struct Birthday {              /* define struct Birthday */
    short day, month, year;
};

struct Student {               /* define struct Student */
    int id;
    char name[32];  
    struct Birthday birthday;  /* contain a nested structure */
};

int main() {
    struct Student s, *sp; /* declare variables */

    /* set s for John */
    sp = &s;      /* sp points to s, so "sp->" is the same as "s." */
    s.id = 101;
    strcpy(s.name, "John");
    /* Set birthday for John September 16, 1990 */
    s.birthday.day = 16;       /* set day */
    s.birthday.month = 8;      /* set month */
    sp->birthday.year = 1990; /* set year, equivalent to s.birthday.year=1990 */
    /* print the information for John in s */
    printf("id   = %d\n", s.id);
    printf("name = %s\n", s.name);
    printf("birthday = %d\n", s.birthday.day);
    printf("birth month = %d\n", s.birthday.month);
    printf("birth year = %d\n", sp->birthday.year);
    return 0;
}
