/* File: accelbino.c
   Write an entire array of acceleration in binary mode into a file */
#include <stdio.h>  /* for fopen(), fclose(), fwrite(), printf() */
#include <stdlib.h> /* for exit() */
#define M_G   9.81  /* gravitational acceleration constant g */
#define N     11    /* number of elements for array a */

int main() {
    /* declaration and initialization */
    double mu=0.2, m=5.0, t0=0.0, tf=10.0, step=1.0, p, t;
    double a[N];     /* declare an array for accelerations */
    int i;           /* index variable */
    FILE *stream;    /* a file stream for writing */

    /* calculate acceleration */
    for(i=0; i<N; i++) {
        t = t0+i*(tf - t0)/(N-1); /* calculate t */
        p = 4*sin(t-3)+20;        /* use t to calculate p */
        a[i] = (p-mu*m*M_G)/m;
    }
    /* open file "accel.bin" for writing in binary mode */
    stream = fopen("accel.bin", "wb"); 
    if(stream == NULL) {
        printf("Error: cannot open 'accel.bin'\n");
        exit(EXIT_FAILURE);
    }
    /* write an entire array of a in binary mode into the file accel.bin */
    fwrite(a, sizeof(double), N, stream);
    fclose(stream);               /* close the file stream */
    printf("Done! Finished writing data to file accel.bin\n");
    return 0;
}
