/* File: byteorder.c
   Write chars, short, int, and float into a binary file. The byte order of
   the data in the binary file can be examined using the program hexdump */
#include <stdio.h>  /* for fopen(), fclose(), fwrite(), printf() */
#include <stdlib.h> /* for exit() */

int main() {
    /* declaration and initialization */
    char c1 = 0x61;     /* ASCII value for decimal value 97 and 'a' */
    char c2 = 0x7a;     /* ASCII value for decimal value 122 for 'z'  */
    short s = 0x4358;   /* ASCII value 0x43 is 'C', 0x58 is 'X' */
    int i = 0x12345678; /* ASCII value 0x12 is not printable character.
                           0x34 is '4', 0x56 is 'V', 0x78 is 'x' */
    float f = 1.0;      /* binary representation of 1.0 is 0x3F800000,
                           ASCII value 0x3F is '?', ASCII values 0x80 and
                           0x00 are not printable character */
    FILE *stream;       /* a file stream for writing */

    /* open file "byteorder.bin" for writing in binary mode */
    stream = fopen("byteorder.bin", "wb"); 
    if(stream == NULL) {
        printf("Error: cannot open 'byteorder.bin'\n");
        exit(EXIT_FAILURE);
    }
    /* write c1, c2, s, i and f into the file byteorder.bin */
    fwrite(&c1, sizeof(char), 1, stream);
    fwrite(&c2, sizeof(char), 1, stream);
    fwrite(&s, sizeof(short), 1, stream);
    fwrite(&i, sizeof(int), 1, stream);
    fwrite(&f, sizeof(float), 1, stream);
    fclose(stream);               /* close the file stream */
    printf("Done! Finished writing data to file byteorder.bin\n");
    return 0;
}
