/* File: copyfile2.c
   Copy a file line by line*/
#include <stdio.h>
#include <stdio.h> /* for fopen(), fclose(), fgets(), fputs(), feof() */
#define BUFSIZE 1024   /* the maximum line size */

int copyfile2(const char *inputfile, const char *outputfile) {
    FILE *fp1, *fp2;   /* declare FILE pointers for input and output files */
    char line[BUFSIZE]; /* the buffer for a line */

    /* open input file for reading and output file for writing 
       in binary mode */
    if((fp1 = fopen(inputfile, "rb")) == NULL)
        return -1; /* if failed to open the file for reading */
    if((fp2 = fopen(outputfile, "wb")) == NULL) {
        fclose(fp1); 
        return -1; /* if failed to open the file for writing */
    }
    fgets(line, BUFSIZE, fp1); /* read a line */
    while(!feof(fp1)) {  /* while not end-of-file */
       fputs(line, fp2); /* write a line into the output file */
       fgets(line, BUFSIZE, fp1); /* read a newline from the input file */
    }
    fclose(fp1);         /* close the file stream for the input file */
    fclose(fp2);         /* close the file stream for the output file */
    return 0;
}
