/* File: fileinfo.c 
   Obtain information about file fileinfo.c */
#include <stdio.h>
#ifdef _WIN32           /* if compiled using Visual Studio .NET */
#define F_OK    0       /* define F_OK for existence of File */
#define X_OK    1       /* define X_OK for eXecute permission */
#define W_OK    2       /* define W_OK for Write permission */
#define R_OK    4       /* define R_OK for Read permission */
#include <io.h>         /* for access() */
#else                   /* all other platforms */
#include <unistd.h>     /* for X_OK, F_OK, R_OK, W_OK and access() */
#endif
#include <sys/stat.h>   /* for struct stat, stat() */

int main() {
    const char *name = "fileinfo.c"; /* file name */
    struct stat stbuf;   /* declare a variable of a stat structure */

    if(!access(name, F_OK)) { /* check if file exists */
        printf("fileinfo.c exists\n");
    }
    if(!access(name, R_OK)) { /* check if file has read permission */
        printf("fileinfo.c is readable \n");
    }
    /* check if file has write and execute permissions */
    if(!access(name, W_OK|X_OK)) {
        printf("fileinfo.c is writable and executable\n");
    }
    if(!stat(name, &stbuf)) { /* check if file is searchable */
       /* print the size of the file */
       printf("fileinfo.c has %d bytes\n",  stbuf.st_size);
       /* print the last modification time */
       printf("fileinfo.c was modified at %d\n",  stbuf.st_mtime);
       printf("fileinfo.c was modified at %s",  ctime(&(stbuf.st_mtime)));
       /* chech if it is a directory or not */
       /* or if(S_ISDIR(stbuf.st_mode)) for POSIX implementation */
       if((stbuf.st_mode & S_IFMT) == S_IFDIR) 
           printf("fileinfo.c is a directory\n");
       else
           printf("fileinfo.c is not a directory\n");
    }
    return 0;
}
