/* File: fwrites.c
   Read and write a binary with using a structure */
#include <stdio.h>  /* for fopen(), fclose(), fread(), fwrite(), remove() */
#include <stdlib.h> /* for exit() */

struct Student {   /* define a structure for students */
    int id;
    char name[32];  
};

int main() {
    /* declare s1 and s2,  initialize s1 */
    struct Student s1 = {101, "John"}, s2; 
    FILE *stream;   /* a file stream for writing and reading */

    /* open a binary file student.bin for writing */
    stream = fopen("student.bin", "wb"); 
    if(stream == NULL) {
      printf("Error: cannot open 'student.bin' for writing.\n");
      exit(EXIT_FAILURE);
    }
    /* write s1 into file student.bin */
    fwrite(&s1, sizeof(struct Student), 1, stream);
    fclose(stream);   /* close the file stream */

    /* open the binary file student.bin for reading, 
       re-use the variable stream */
    stream = fopen("student.bin", "rb"); 
    if(stream == NULL) {
      printf("Error: cannot open 'student.bin' for reading.\n");
      exit(EXIT_FAILURE);
    }
    /* read the contents in file student.bin in s2 */
    fread(&s2, sizeof(struct Student), 1, stream);
    fclose(stream);   /* close the file stream */

    /* print out the contents of structure s2 */
    printf("s2.id   = %d\n", s2.id);
    printf("s2.name = %s\n", s2.name);
    remove("student.bin"); /* remove file student.bin */
    return 0;
}
