/* File: geturlfile.c
   Get URL Web addresses from an HTML file */
#include <stdio.h>      /* for fopen(), fclose(), fgets(), feof(), printf() */
#include <string.h>     /* for strstr(), strchr(), strcpy(), strncpy() */
#include <stdlib.h>     /* for exit() */
#define LINESIZE 1024   /* the maximum input line length */

int main(int argc, char *argv[]) {
    /* declare strings line for the input string, url for URL address 
       beginptr for the beginning of the URL address, 
       endptr for the end of the URL address */
    char line[LINESIZE], url[LINESIZE], *beginptr, *endptr;
    int len;               /* the len of the URL address */
    FILE *stream;          /* declare a file stream */
    /* declare variables for cmd, file name, and default file name */
    char *cmd, *filename, dfilename[] = "geturlfile.html";

    cmd = argv[0];         /* save the command */
    if(argc > 2){          /* extra argument */
        fprintf(stderr, "Usage: %s [filename]\n", cmd);
        exit(EXIT_FAILURE);
    }
    /* get the user specified or default file name */
    filename = (argc == 2 ? argv[1]:dfilename);
    stream = fopen(filename, "r"); /* open the file for reading */
    if(stream == NULL) {
        printf("Error: cannot open '%s'\n", filename);
        exit(EXIT_FAILURE);
    }

    fgets(line, LINESIZE, stream); /* read a line from the file */
    while(!feof(stream)) {         /* read the file until EOF */
      /* find "http:// in the string */
      /* There might be multiple URL addresses in the user input line */
      while (beginptr = strstr(line, "\"http://")) {
         beginptr++; /* skip " in "http:// */
         /* find the closing " */
         endptr = strchr(beginptr, '"');
         if(endptr != NULL)  /* when there is " */
         {
            /* calculate the length of the URL address */
            len = endptr - beginptr;
            strncpy(url, beginptr, len); /* copy URL address to url */
            url[len] = '\0';        /* append a null character for url */
            printf("%s\n",url );    /* got a URL, print it */
            strcpy(line, endptr);   /* update string line to find next URL */
         }
         else {/* set line to a null terminating character to quit while-loop */
            line[0] = '\0';
         }
      }
      fgets(line, LINESIZE, stream); /* read a line from the file */
    }
    fclose(stream);                  /* close the file stream */
    return 0;
}
