/*************************************************************
* File: student.c
* This program tests the GPA library with data in an array
*************************************************************/
#include <stdio.h>
#include "studentfile.h"   /* header file for GPA library */

/* the database for students' GPA,
   more students can be added */
student_t data[] = {
    {101, "John",   12, 11, 1985, 3.33},
    {102, "Doe",    13, 3,  1988, 3},
    {103, "Peter",  21, 4,  1984, 3.1},
    {104, "Mary",   8,  2,  1985, 3.93},
    {105, "Ron",    30, 12, 1986, 2.3},
    {106, "George", 9,  1,  1987, 2.31},
    {107, "Mike",   10, 8,  1986, 3.99},
    {108, "Steve",  17, 5,  1989, 2.8},
    {109, "Jone",   25, 4,  1990, 2.9},
    {110, "Ron",    6,  11, 1988, 3.7},
    {GPA_EOD, NULL, GPA_EOD, GPA_EOD, GPA_EOD, GPA_EOD} /* terminating element */ 
};

int main() {
    student_t *head, *sp; /* head of the list and a single student */
    double gpa;           /* GPA value */
    struct Birthday b;    /* b for birthday */
    int num; /* number of students with GPA above a specified value */
   
    head = data;          /* head of the list */ 
    printf("The total number of students is %d\n", gpa_totnum(head));
    gpa = gpa_averageGPA(head); /* GPA for all students */
    printf("The GPA for all students is %.2f\n", gpa);
    sp = gpa_highestGPA(head); /* find the student with the highest GPA */
    b = gpa_getBirthday(sp);   /* get the birthday of this student */
    printf("%s who was born on %s %d, %d has the highest GPA %.2f\n",
           gpa_getName(sp), gpa_monthString(b.month), b.day, b.year, 
           gpa_getGPA(sp));
    printf("The student with the lowest GPA:\n");
    sp = gpa_lowestGPA(head);  /* find the student with the lowest GPA */
    gpa_printStudent(sp);      /* print infor for this student */ 
    /* find the student with ID 103 and named 'Peter' */
    sp = gpa_find(head, 103, "Peter");
    if(sp) {  /* if Peter is in the list, get and print his GPA */
      printf("Peter's GPA is %.2f\n", gpa_getGPA(sp));
    }
    printf("Students with GPA 3.0 or above:\n");
    /* get the number of students with GPA above 3.0 and print them out */
    num = gpa_aboveGPA(head, 3.0); 
    printf("%d students with GPA 3.0 or above.\n", num);
    gpa_sortGPA(head);   /* sort students in the list based on GPA */
    printf("The student record sorted in descending GPA:\n");
    gpa_printList(head); /* print info for students in the sorted list */
    return 0;
}
