/* Fil: list.c 
   Create and manipulate a singly linked list */
#include <stdio.h>
#include "list.h"   /* header file for singly linked list */

int main() {
    Node head, nd;  /* head and a node of the list */
    /* create four nodes of a list */
    Node nd1 = createNode(101, "John"),
         nd2 = createNode(102, "Doe"),
         nd3 = createNode(103, "Peter"),
         nd4 = createNode(104, "Mary");

    head = NULL;          /* initialize head of the list */
    prepend(&head, nd1);  /* prepend node nd1 to head of the list */
    printf("List with one node:\n"); 
    printList(head);      /* print the list 1st time */
    prepend(&head, nd2);  /* prepend node nd2 to the head of the list */
    printf("List with node for Doe prepended in head:\n");
    printList(head);      /* print the list 2nd time */
    append(&head, nd3);   /* append node nd3 to the list */
    printf("List with node for Peter appended:\n"); 
    printList(head);      /* print the list 3rd time */
    insert(&head, nd4, 2);/* insert node nd4 at 2nd place of the list */
    printf("List with node for Mary at the 2nd place:\n");
    printList(head);     /* print the list 4th time */

    nd = find(head, 102, "Doe"); /* find node with id 102 and name Doe */
    remov(&head, nd);     /* remove this node from the list */
    printf("List without node for Doe:\n"); 
    printList(head);     /* print the list 5th time */
    nd = find(head, 101, "John");/* find node with id 101 and name John */
    remov(&head, nd);     /* remove this node from the list */
    printf("List without node for John:\n"); 
    printList(head);      /* print the list 6th time */
    clearList(head);      /* clear the list */
    return 0;
}
