/* a self-referencing structure for a queue node */
struct QueueNode {
    /* data for each node */
    ...
    struct QueueNode *next;     /* link to the next node */
};
typedef struct QueueNode *Node; /* define type Node */

/* insert a node at queue tail */
void enqueue(Node *head, Node *tail, Node nd) {
    if(*head == NULL) {   /* no node in queue */
      *head = nd;         /* nd becomes head */
    }
    else {
      (*tail)->next = nd; /* append nd to tail */
    }
    *tail = nd;           /* update tail */
}

/* delete a node from queue head */
void dequeue(Node *head, Node *tail) {
    Node tmp = *head;     /* tmp is the head of the list */

    if (*head == NULL)    /* empty node */
      return;
    else {                
      *head = (*head)->next;
      freeNode(tmp);      /* free the memory for the head node */
      if(*head == NULL)   /* empty queue now */
        *tail = NULL;     /* set tail to NULL also */
    }
}   
