/* File: expx.cpp
   Calculate and plot e^(1/x) in the range of [-10, 10].
   Data in the range [-0.5, 0.5] are not plotted */
#include <math.h>
#include <chplot.h>  /* for CPlot */

#define NUM 100      /* number of points for each curve */
int main() {
    /* declare variables */
    double x0, xf, x1[NUM], x2[NUM], f1[NUM], f2[NUM];
    CPlot plot;
    int i;

    x0 = 0.5;   /* initial value, use 0.5 to avoid 0.0 in the plotting */
    xf = 10.0;  /* final value */
    for(i=0; i< NUM; i++) {             /* use a loop to generate data */
        x1[i] = x0 + i*(xf-x0)/(NUM-1);
        f1[i] = exp(1.0/x1[i]);
        x2[i] = -x1[i];                 /* symetrical about y axis */
        f2[i] = exp(1.0/x2[i]);
    }
    plot.label(PLOT_AXIS_X, "x");        /* x label */
    plot.label(PLOT_AXIS_Y, "exp(1/x)"); /* y label */
    plot.data2DCurve(x1, f1, NUM);       /* curve for x in [0.5, 10] */
    plot.data2DCurve(x2, f2, NUM);       /* curve for x in [-10, -0.5] */
    plot.line(-10, 1, 0, 10, 1, 0);      /* draw a horizontal line */
    plot.line(0, 0, 0, 0, 8, 0);         /* draw a vertical line */
    plot.plotting();                     /* plot it */
    return 0;
}
