/* File: metanums.c (run in C99 and Ch only)
   Compile in gcc, use command 'gcc -std=c99 metanums.c' 
   Use metanumbers INFINITY and NAN, and printf() with metanumbers
 */
#include <stdio.h>
#include <math.h> /* for INFINITY and NAN */

int main() {
    float finf, fnan;    /* declare variables of float */
    double dinf, dnan;   /* declare variables of double */

    finf = INFINITY;     /* Inf */
    fnan = NAN;          /* NaN */
    dinf = INFINITY;     /* Inf */
    dnan = NAN;          /* NaN */
    printf("The float   Inf  = %f\n", finf);
    printf("The float  -Inf  = %f\n", -finf);
    printf("The float   NaN  = %f\n", fnan);
    printf("The double  Inf  = %f\n", dinf);
    printf("The double -Inf  = %f\n", -dinf);
    printf("The double  NaN  = %f\n", dnan);
/* If the program runs in Ch, %b format is used to display
   the binary representation of floating-point numbers */
#ifdef _CH_
    printf("The float   Inf  = %b \n", finf);
    printf("The float  -Inf  = %b \n", -finf);
    printf("The float   Nan  = %b \n", fnan);
    printf("The double  Inf  = %b \n", dinf);
    printf("The double -Inf  = %b \n", -dinf);
    printf("The double  NaN  = %b \n", dnan);
    printf("The int     2    = %b \n",  2);   /* only display 2 bits */
    printf("The int     2    = %32b \n",  2); /* display 32 bits */
    printf("The int    -2    = %b \n", -2);   /* display 32 bits */
    printf("The float   0.0F = %b \n", 0.0F);
    printf("The float  -0.0F = %b \n", -0.0F);
    printf("The float   1.0F = %b \n",  1.0F);
    printf("The float  -1.0F = %b \n", -1.0F);
    printf("The float   2.0F = %b \n",  2.0F);
    printf("The float  -2.0F = %b \n", -2.0F);
#endif
    return 0;
}
