/* File: newhandler.cpp
   Set handler called when the 'new' operator fails 
    */
#include <iostream>      
#include <new>           // For function set_new_handler()
#include <limits.h>      // for INT_MAX
#include <stdio.h>       // for printf() 
using namespace std;

void newhandler(void);   // function prototype 

int main() {
    char *p = new char [10];       // Ok
    printf("p = %p\n", p);

    char *p1 = new char [INT_MAX]; // No memory, no error handler
    printf("p1 = %p\n", p1);

    set_new_handler(newhandler);   // set error handler

    char *p2 = new char [INT_MAX]; // No memory, with error handler
    printf("p2 = %p\n", p2);

    char *p3 = new char [INT_MAX]; // No memory, with error handler
    printf("p3 = %p\n", p3);

    /* delete allocated memory */
    if(p)
      delete p;
    if(p1)
      delete p1;
    if(p2)
      delete p2;
    if(p3)
      delete p3;
    return 0;
}

/* error handler for the 'new' operator */
void newhandler(void) {
    printf("Error: new operator failed\n");
    /* exit(1); */
}
