/* File: CBody.cpp
   Definition of member functions of class CBody */
#include <math.h>     // for sin()
#include <chplot.h>   // for plotxy()
#include "accel.h"    // for class CBody definition

CBody::CBody() {      // constructor
    m_mu = 0;         // initialize mu with 0
    m_m = 0;          // initialize m with 0
}

CBody::~CBody() {     // destructor (empty)
    ;
}

void CBody::setSys(double mu, double m) {  /* set system for mu and m */
    m_mu = mu;
    m_m = m;
}

double CBody::force(double t) {    /* calculate force */
    double p;

    p = 4*(sin(t-3))+20;
    return p;
}

double CBody::accel(double t) {   /* calculate acceleration */
    double a, p;

    p = force(t);
    a = (p-m_mu*m_m*M_G)/m_m;
    return a;
}

/* plotting accel versus time  */
void CBody::plotAccel(double t0, double tf) {  
    double a[N], t[N];   /* define arrays for plotting */
    int i;

    for(i; i<N; i++) {
      t[i] = t0 + i*(tf-t0)/(N-1); 
      a[i] = accel(t[i]);
    }
    plotxy(t, a, N, "Acceleration Plot", "time (s)", "accel (m/s^2)");
}
