/* File: membercout.cpp
   Use private member function and cout */
#include <string.h>        // for strcpy()
#include <iostream>        // for I/O in C++ 
using namespace std;       // for using cout, cin, cerr, endl 

class CStudent{     // define class CStudent
    public:         // declare public member functions            
      CStudent(int id, char *name); // constructor
      ~CStudent();                  // destructor
      void print();                 // member function
      int getId();                  // member function
    private:        // declare private data and member function
      int m_id;                     // private data
      char *m_name;                 // private data
      int m_checkId(int id);        // private member function

};

CStudent::CStudent(int id, char *name) { // constructor definition
    if(!m_checkId(id))
      m_id = id;
    else
      m_id = -1;
    if(name != NULL) {
      m_name = new char[strlen(name)+1]; // allocate memory for name
      strcpy(m_name, name);
    }
}

CStudent::~CStudent() {                  // destructor definition
    if(m_name != NULL) {
       delete(m_name);                   // free the allocated memory
    }
    cout << "Destructor ~CStudent() is called\n";
}

void CStudent::print() {                  // print student info
    cout << "m_id   = " << m_id <<endl;
    cout << "m_name = " << m_name <<endl;
}

int CStudent::getId() {                   // get ID
    return m_id;
}

/* private member function definition to check ID */
int CStudent::m_checkId(int id) {         
    if(id <= 0) {
       cout << "Error: " << id << " is invalid id\n";
       return -1;
    }
    else
       return 0;
}

int main() {
    CStudent s1 = CStudent(101,"John");
    CStudent s2 = CStudent(-10,"Doe");    // -10 is an invalid ID
    int id;

    id = s1.getId();
    cout << "id = " << id << endl;
    id = s2.getId();
    cout << "id = " << id << endl;
    return 0;
}

