/* File: nested.cpp
   Use nested classes */
#include <iostream>     // for I/O in C++
using namespace std;    // for using cout, cin, cerr, endl

class Encl {      // define class Encl
    public:       // public members  
        Encl(int);            // constructor
        ~Encl();              // destructor  
        int getVar();         // member function
        class nestPub { // define nested class nestPub
            public:
                int getVar1();         // nested public function
                void setVar1(int var); // nested public function
            private:
                int variable1; // nested private function
        } pubelement;
    private:      // private members
        class nestPrv { // define nested class nestPrv
            public:
                int getVar2();        // nested public function
            private:
                int variable2; // nested private function
        } prvelement;
        int variable;          // define private variable
};

Encl::Encl(int var) { // constructor
    variable = var;
}
Encl::~Encl() {       // destructor
}

int Encl::getVar() { // member function
    return variable;
}

int Encl::nestPub::getVar1() { // nested public function
    return variable1;
}

void Encl::nestPub::setVar1(int var) { // nested public function
    variable1 = var;
}

int Encl::nestPrv::getVar2() { // nested private function
    return variable2;
}

int main() {
   Encl e = Encl(5); 
   cout << "variable = " << e.getVar() << endl; 
   e.pubelement.setVar1(10);
   cout << "variable1 = " << e.pubelement.getVar1() << endl; 
   return 0;
}
