/* File: staticmem.cpp 
   Use static member in a class */
#include <string.h>        // for strcpy()
#include <iostream>        // for I/O in C++
using namespace std;       // for using cout, cin, cerr, endl
class CStudent{     // define class CStudent
    public:
      CStudent(int id, char *name);
      ~CStudent();
      void print();
      int getCount();   
    private:
      int m_id;
      char *m_name;
      static int m_count; // declare static member m_count
};
int CStudent::m_count=0;  // allocate memory and initialize static member

CStudent::CStudent(int id, char *name) {
    m_id = id;
    if(name != NULL) {
      m_name = new char[strlen(name)+1];
      strcpy(m_name, name);
    }
    m_count++;           // use static member m_count
}
CStudent::~CStudent() {
    if(m_name != NULL) {
       delete(m_name);
    }     
    m_count--;           // use static member m_count
    cout << "Destructor ~CStudent() is called\n";
}

void CStudent::print() {
    cout << "m_id   = " << m_id <<endl;
    cout << "m_name = " << m_name <<endl;
}

int CStudent::getCount() {
    return m_count;   // return CStudent::m_count;
}

int main() {
    CStudent *sp1 = new CStudent(101,"John");
    cout << "m_count from sp1->getCount() = " << sp1->getCount() << endl;

    CStudent *sp2 = new CStudent(102,"Doe");
    cout << "m_count from sp1->getCount() = " << sp1->getCount() << endl;
    cout << "m_count from sp2->getCount() = " << sp2->getCount() << endl;

    delete (sp1);
    cout << "m_count from sp2->getCount() = " << sp2->getCount() << endl;
    delete (sp2);
    return 0;
}
