/* File: thisptr.cpp
   Use 'this' pointer */
#include <string.h>        // for strcpy()
#include <iostream>        // for I/O in C++
using namespace std;       // for using cout, cin, cerr, endl

class CStudent{            // define class CStudent
    public:
      CStudent(int id, char *name);
      ~CStudent();
      void print();
    private:
      int m_id;
      char *m_name;
};


CStudent::CStudent(int id, char *name) {
    this->m_id = id;           // Use 'this' pointer 
    if(name != NULL) {
      m_name = new char[strlen(name)+1];
      strcpy(m_name, name);
    }
}

CStudent::~CStudent() {
    if(this->m_name != NULL) { // use 'this' pointer 
       delete(this->m_name);
    }
}

void CStudent::print() {
    double m_id = 12.34;

    /* use 'this' pointer */
    cout << "this->m_id   = " << this->m_id <<endl;
    cout << "this->m_name = " << this->m_name <<endl;
    cout << "m_id   = " << m_id <<endl;
}

int main() {
    CStudent s = CStudent(101,"John");

    s.print();
    return 0;
}
