/* File: filledcurve.cpp 
   Plot data in a filled curve */
#include <chplot.h> // for CPlot

int main() {
    /* declare and initialize the original data */
    double t[] = {0.0, 3.0, 5.0, 8.0,  10.0, 12.0, 15.0, 18.0};
    double y[] = {2.0, 5.2, 6.0, 10.0, 10.4, 13.4, 14.8, 18.0};
    int n, num=0;  // number of data points and data set number
    CPlot plot;    // instantiate a plotting class 
    int linetype, linewidth;

    n = sizeof(t)/sizeof(double); // calculate the number of data points 

    /* Setup for the entire plot */
    plot.label(PLOT_AXIS_X, "t (second)");
    plot.label(PLOT_AXIS_Y, "y (meter)");
    plot.border(PLOT_BORDER_ALL, PLOT_ON); // display all four boards 
    /* add grid, always on the front with line width 2 */
    plot.grid(PLOT_ON, "front linewidth 2");

    /* add data t[] and y[] as the 1st set of data for plotting
       in filled curve with axis y1=0 and color specified by line type 2 */
    plot.data2DCurve(t, y, n);
    plot.plotType(PLOT_PLOTTYPE_FILLEDCURVES, num, "y1=0");
    linetype = 1;   // line type 
    linewidth = 1;  // line width 
    plot.lineType(num, linetype, linewidth, "green");

    /* add data t[] and y[] as the 2nd set of data for plotting in lines */
    plot.data2DCurve(t, y, n);
    linetype = 1;   // line type 
    linewidth = 4;  // line width,
    plot.lineType(++num, linetype, linewidth, "red");

    plot.plotting();
    return 0;
}
