/* File: helix.ch 
   Plot 3D curve using plotxyz() with computational array */
#include <math.h>    // for sin() and cos()
#include <chplot.h>  // for plotxyz() and 'array' type qualifier

#define N 300        // number of data points for the 3D curve 

int main() {
    /* declare arrays for plotting, t is coordinates in z-axis  */
    array double x[N], y[N], t[N];

    lindata(0, 10*M_PI, t); // fill array t from 0 to 10PI linearly
    x = sin(t);             // calculate array x with sin(t)
    y = cos(t);             // calculate array y with cos(t)
    /* plot 3D curve using plotxyz() */
    plotxyz(x, y, t, N, "Helix", "sin(t)", "cos(t)", "t");
    return 0;
}
