/* File: passassumeshape.ch 
   Pass variable length arrays to a function using assumed-shape arrays */
#include <stdio.h>
#include <array.h>   // for 'array' type qualifier

/* function passes variable length arrays using assumed-shape arrays a and b */
double sum3(array double a[:][:], array double b[:][:]){
    /* obtain n and m, the number of rows and columns */
    int n = shape(a, 0), m = shape(a, 1);
    /* or array int dim[2] = shape(a);
          int n = dim[0], m = dim[1]; */
    double sum = 0;
    int i, j;

    printf("n = %d, m = %d\n", n, m); // print passed n and m
    b = a + 2 * a;        // matrix computation for b = 3*a
    for(i=0; i<n; i++)    // sum all elements of array a
       for(j=0; j<m; j++)
          sum += a[i][j];
    return sum;
}

int main() {
    double sum;
    array double b1[2][3], a1[2][3] = {1, 2, 3,
                                    4, 5, 6};
    array double b2[3][4], a2[3][4] = {1, 2, 3, 4,
                                    5, 6, 7, 8, 
                                    9, 10, 11, 12};


    sum = sum3(a1, b1);            // pass 2x3 matrices a1 and b1
    printf("b1 = \n%g", b1);       // print b1 passed back from sum2()
    printf("sum = %g\n\n",  sum);
    sum = sum3(a2, b2);            // pass 3x4 matrices a2 and b2
    printf("b2 = \n%g", b2);       // print b2 passed back from sum2()
    printf("sum = %g\n",  sum);
    return 0;
}
