/* File: passfullarray.ch
   Pass fully-specified-shape arrays to a function  */
#include <stdio.h>
#include <array.h>   // for 'array' type qualifier
#define N 2          // number of rows of arrays a and b 
#define M 3          // number of columns of arrays a and b

/* function passes fully-specified-shape arrays a and b */
double sum1(array double a[N][M], array double b[N][M]) {
    double sum = 0;
    int i, j;

    b = a + 2 * a;        // matrix computation for b = 3*a
    for(i=0; i<N; i++)    // sum all elements of array a
       for(j=0; j<M; j++)
         sum += a[i][j];
    return sum;           // return the sum of all elements of array a
}

int main() {
    double sum;
    array double b[N][M], a[N][M] = {1, 2, 3,
                                     4, 5, 6};

    sum = sum1(a, b);
    printf("b = \n%g", b);   // print b passed back from sum1()
    printf("sum = %g\n",  sum);
    return 0;
}
