% File: acceldata2DCurve.m
g = 9.81;
N1 = 11;
N2 = 100;
mu = 0.2;
m = 5.0;
t0 = 0.0;
tf = 10.0;

for i=1:N1
   t1(i) = t0+(i-1)*(tf - t0)/(N1-1);
   p1 = 4*sin(t1(i)-3)+20;
   a1(i) = (p1-mu*m*g)/m;
end

for i=1:N2
   t2(i) = t0+(i-1)*(tf - t0)/(N2-1);
   p2 = 4*sin(t2(i)-3)+20;
   a2(i) = (p2-mu*m*g)/m;
end

plot(t1, a1);
xlabel('time (s)');
ylabel('accel (m/s^2)');
title('Acceleration Plot');
hold;                              % one plot with two curves
plot(t2, a2, '.');                 % using points for the 2nd curve
legend('11 points', '100 points'); % add legends
