/* File: accelsinmpts.cpp
   Plot accelereration versus time with 100 points */
#include <stdio.h>
#include <math.h>
#include <chplot.h>     /* for plotxy() */

#define M_G   9.81      /* gravitational acceleration constant g */
#define N     100       /* num of points for plotting */

int main() {
    /* declare variables for accel, time, mu, mass, force */
    double a[N], t[N], t0, tf;
    double mu, m, p;
    int i;

    /* set mu, mass, initial time, and final time */
    mu = 0.2;    
    m = 5.0;
    t0 = 0.0;
    tf = 10.0;

    for(i=0; i<N; i++) {             /* go through the loop N times */
        t[i] = t0+i*(tf - t0)/(N-1); /* calculate element t[i] for time */
        p = 4*sin(t[i]-3)+20;        /* calculate force p */
        a[i] = (p-mu*m*M_G)/m;       /* calculate element a[i] for accel */
    }

    /* call plotting function in the plotting library */
    plotxy(t, a, N, "Acceleration Plot", "time (s)", "accel (m/s^2)");
    return 0;
}
